#ifndef SEM_CONSISTENCY_H
#define SEM_CONSISTENCY_H

#include "machine.h"



/***** procedures for variable evaluation and selection *****/

int  nr_of_top_level_constraints_at_variable();
/* int  nr_of_top_level_constraints_at_variable(WORD* var); */

int  nr_of_appearances();
/* int  nr_of_appearances(WORD* var, sem_junct* junct); */

float  AverageDagTC_of_SemEqConstrsAtVariable();
/* float  AverageDagTC_of_SemEqConstrsAtVariable(WORD* var); */

float compute_variable_difficulty();
/* float compute_variable_difficulty(WORD* myVar);
 *
 * Rates how difficult it's (probably) going to be to find an
 *  instantiation for myVar  
 * the more difficult, the higher the return value */


/**************** procedures for backtracking ********************/

int  backtrack();
/* int  backtrack(history_list*  historyListPtr,
                  choice_pt*     choicepoint,
		  history_list*  historyForCanlListPtr); */


/****************** procedures for instantiation ********************/

/* Try to recreate a solution of the constraint net for choicePoint:
   returns
   TRUE   if successfull
   FALSE  otherwise
   */
void recompute_solution();
/* void recompute_solution(choice_pt* choicePoint); */

int are_sem_equ_constraints_consistent();
/* int are_sem_equ_constraints_consistent(int            nrTreesToCheck,
				          int            alive_flag,
					  choice_pt*     choicepoint,
					  history_list*  historyListPtr,
					  history_list*  historyForCanlListPtr); */


/*************** procedures for consistency checks *****************/

int  global_consistency();
/* int  global_consistency(choice_pt* curChp,
                           int        keep_instantiations); */

int try_to_instantiate_trees();
/* int try_to_instantiate_trees(choice_pt*  chpt
                                int         nrTreesToCheck); */
/* - check the local consistency of the actual constraint net
   - return TRUE   if the net is local consistent
     return FALSE  otherwise
 */

/* The constraints of a variable are 1-consistent, if there's an instantiation for
 * this variable which fulfills these constraints.
 * return TRUE, if var's constraints are 1-consistent
 * return FALSE otherwise */
int one_consistency_check();
/* int one_consistency_check(WORD*  varList,
                             int    nrVars,
			     int    GETPTR_flag,
			     int    deleted_flag); */


#endif /* SEM_CONSISTENCY_H */
