/******************************************************/
/*    S E T H E O                                     */
/*                                                    */
/* FILE: i_conjconstr.c                               */
/* VERSION:                                           */
/* DATE:                                              */
/* AUTHOR:                                            */
/* NAME OF FILE:                                      */
/* DESCR:                                             */
/* MOD:                                               */
/* BUGS:                                              */
/******************************************************/

#include <stdio.h>
#include "tags.h"
#include "machine.h"
#include "deref.h"
#include "errors.h"
#include "disp.h"
#include "unitlemma.h"
#include "sem_constr.h"
#include "sem_tools.h"
#include "univ_constr.h"

#define INSTR_LENGTH		2
#define LOCAL_DEBUG



/*************** creation of the sem_constr-tree ******************/

instr_result i_conjconstr()
{
  WORD*            topList;
  WORD*            constraint;
  WORD*            leftList;
  WORD*            rightList;
  sem_junct*       rootJunct;
  sem_junct*       curJunct;
  int              mySuccess = FALSE;


  topList = deref(ARGV(0), bp);
  
  /* is topList a list? */
  check_list(topList);
    
  /* create rootJunct on the constraint-stack
   * rootJunct is the disjunctor between the equality-subconstraints */ 
  rootJunct = add_new_sem_junct(NULL, JUNCT_CONJ); /* parent_junct is NULL */
    
  /******************************************************************/
  /* Process elements of topList:                                   */
  /******************************************************************/
    
  while (GETSYMBOL(*topList) == LISTFUNCT) {
    
    constraint = deref(topList+1, bp);
    
    /* constraint has to be a list with two elements,
     * that are nonempty lists themselves 
     * Extract these two lists and write them into
     * leftList and rightList */
    extract_constraint_sides(constraint, &leftList, &rightList);
          
    if (list_length(leftList) != list_length(rightList))
      sam_error("conjconstr: The constraint-sides are unbalanced", NULL, 2);

    pu_tr = pu_trail;

    if (un_protoco(leftList, bp, rightList, bp, 1)) {
      if (pu_tr != pu_trail) {
	/* create curJunct on the constraint-stack
	 * curJunct is the disjunctor between the elementary-constraints */ 
	curJunct = add_new_sem_junct(rootJunct, JUNCT_DISJ); 
	/* parent_junct is the rootJunct */

	/* WARNING: bitte noch mal checken, ob das so funktioniert: */
	generate_sem_elem_constraints_from_pu_trail(curJunct,
						    ELEM_DIFF, 
						    TRUE);
	mySuccess = TRUE;
      }
    }
    else {
       pu_untrail();
       mySuccess = TRUE;
    }
    
    topList = deref(topList+2, bp); /* next element of topList */
    check_list(topList);
  }

  if (! mySuccess)
    return failure;

  if (rootJunct->arity == 0)
    /* remove rootJunct, as no constraints were generated */
    c_sp = (WORD*) rootJunct;
  else {
#ifdef LOCAL_DEBUG
    print_sem_constr_tree(rootJunct, 0);
    printf("\n");
    fflush(stdout);
#endif /* LOCAL_DEBUG */
  }

  pc +=INSTR_LENGTH;
  return success;
}




