/************************************************************/
/*    S E T H E O                                           */
/*                                                          */
/* FILE: i_proceed.c                                        */
/* VERSION:                                                 */
/* DATE: Fri Sep  4 11:13:37 MET DST 1992                   */
/* AUTHOR:                                                  */
/* NAME OF FILE:                                            */
/* DESCR:                                                   */
/* MOD:                                                     */
/*	11.3.93	Mueller,Goller neue Constraints, Statistics */
/* BUGS:                                                    */
/************************************************************/

#include <stdio.h>
#include "constraints.h"
#include "tags.h"
#include "machine.h"
/**/
#include "bounds.h"
#include "deref.h"
#include "termcomplexity.h"
/* Begin: SEMANTIC */
#include "sem_consistency.h"
#include "sem_tools.h"
/* End: SEMANTIC */

#ifdef STATPART
#include "sps.h"
#endif

#define INSTR_LENGTH		1


instr_result i_proceed()
{
    int       tc;
/* Begin: SEMANTIC */
    c_counter *lptr;
/* End: SEMANTIC */

    /* update bp->chp->end_total_inf antilemmata before starting the
       global_consistency-check */

#ifdef ANTILEMMATA
    if (anl_constr) {
        if (inf_bound) {
            chp->end_infcount = infcount;
        }
        chp->end_total_inf = total_inf;
    }
#endif


/* Begin: SEMANTIC */
    if (sem_constrs_in_proof) {
       if (check_local_consistency(chp, nr_trees_to_check) == FALSE) {
#ifdef STATISTICS1
	  loc_cons_fails++;
#endif
	  chp->consistency_fail_occurred = TRUE;
	  return failure;
       }
       if (!global_consistency(chp, FALSE))
	  return failure;
    }

    /********************************************************/
    /* use local variable lptr for deactivating constraints */
    /********************************************************/
    lptr = c_counter_sp;
    while (lptr > chp->deact_c_counter_sp) {
       /*********************************************************************/
       /* If (      constraint is still active                              */
       /*      and (    constr is a loc-cons-anl constr                     */
       /*            or constr is a gl-cons-anl constr                      */
       /*            or constr is a i-cons-anl constr                       */
       /*          )                                                        */
       /*    )                                                              */
       /* then trail and deactivate constr.                                 */
       /*********************************************************************/
       if (lptr->length != -1                  
	   && (GETTAG(lptr->next) == LOC_CONS_ANL
	       ||  GETTAG(lptr->next) == GL_CONS_ANL
	       ||  GETTAG(lptr->next) == I_CONS_ANL)) {
	  trail_int(&lptr->length);
	  lptr->length = -1;
       }
       lptr = (c_counter *) GETPTR(lptr->next);
    }
/* End: SEMANTIC */


#ifdef ANTILEMMATA
    if (anl_constr) {
        /*******************************************************************/
        /* Whenever a subgoal has been solved we have to store the current */
        /* trail pointer for further use in antilemma constraints          */
        /*******************************************************************/
        trail_ptr((void**)&(chp->end_trail));
        chp->end_trail = tr;
    }
#endif

/* Begin: SEMANTIC */
    chp->end_chp = chp;
/* End: SEMANTIC */

#ifdef TC_BOUND
    if (tc_bound  &&  sgscount) {
	tc = tc_of_all_open_subgoals();
	if (tc_bound_fail(tc))
	    return failure;
        if (tc > intmd_tc)
            intmd_tc = tc;
    }
#endif

    pc = ra;

#ifdef STATPART
        /* IAbegin */
	if( recomp && iand_task_num != -2) /* IA-Task vorhanden */
	if( bp == saved_bp )
	  {
	  /*
	    printf("i_proceed: now_next_subg = TRUE; next?= ");
	    print_subgoal(stdout,bp->lcbptr,bp,0);
	    printf("\n");
	    */
            trail_var(&now_next_subg);
            now_next_subg = TRUE;
	  }
        /* IAend */
#endif

    return success;
}
